/**
 * 
 */

var debug=false;

var eventsInitialised=false;

var animationRate=0;

var timerLoop;
var simSpeed=500;
var loopBegin=0;
var loopEnd=0;
var simulationIndex=-1;
var showVarValues=true;
var xSim=0;
var iSim=0;
var outputSim=0;
var outputConditional=false;
var iInitialised=false;
var codeLength=0;
var hideSimulationPath=true;
var programOutput="";
var outputIndex=-1;
var generateNewValueIndex=-1;
var simulationInitialised=false;

var jQueryAnimationRate=0;
var helpShown=false;

var exerciseVariation=0;

var requestConfirmation=false;
var dontRequestConfirmation=true;
var requestConfirmationState=requestConfirmation;

//*************************************************************
//* Οι ακόλουθες τιμές θα οριστούν στην defineExerciseTypes() *
//*************************************************************
//var determineNoOfRepetitions=1;
var twoVariables=0;
var request_xStart=0;
var request_xStep=0;
var swapLoopBody=0;
var loopVarExpression=0;
var loopFrom=0;
var loopTo=0;
var loopStep=0;
var request_loopStep=0;
var outputWithConditional=0;
var request_OutputConditional=0;
var request_OutputExpression=0;

//Ειδικές τιμές
var loopStartFrom=0;
var loopEndTo=0;
var loopStepValue=2;
var xStep=2;
var xStart=0;
var iExpression=[" 2 * i - 4","2 * (i - 2)"];
var iExpressionSelector=0;
var xExpression="x";
var iConditional="i MOD 2 = 0";
var xConditional="x MOD 2 = 0";

var difficultyLevel=-1;
var difficultyThreshold=0;

var generateFullCode=0; //Παραγωγή εκφώνησης
var generatePartialCode=1; //Παραγωγή απάντησης

var solutionOutputVisible=false;
var userOutputVisible=false;

//Μεταβλητές για παροχή βοήθειας στον εντοπισμό σφάλματος
var noSyntaxError=0;
var xStartError=1;
var loopFromError=2;
var loopToError=4;
var loopStepError=8;
var xConditionalError=16;
var iConditionalError=32;
var xExpressionError=64;
var iExpressionError=128;
var xStepError=256;
var errorCodes=[xStartError,
                loopFromError,
                loopToError,
                loopStepError,
                xConditionalError,
                iConditionalError,
                xExpressionError,
                iExpressionError,
                xStepError,
                noSyntaxError];
var errorLocation=noSyntaxError;

var syntaxError=["Σφάλμα στην τιμή της μεταβλητής <code>x</code>.",
                 "Σφάλμα στην παράμετρο <code>ΑΠΟ</code> της Δομής Επανάληψης.",
                 "Σφάλμα στην παράμετρο <code>ΜΕΧΡΙ</code> της Δομής Επανάληψης.",
                 "Σφάλμα στην παράμετρο <code>ΜΕ_ΒΗΜΑ</code> της Δομής Επανάληψης.",
                 "Σφάλμα στη Δομή Επιλογής για τη μεταβλητή <code>x</code>.",
                 "Σφάλμα στη Δομή Επιλογής για τη μεταβλητή <code>i</code>.",
                 "Σφάλμα στην παράμετρο της εντολής <code>ΓΡΑΨΕ</code> (αλγεβρική έκφραση της μεταβλητής <code>x</code>).",
                 "Σφάλμα στην παράμετρο της εντολής <code>ΓΡΑΨΕ</code> (αλγεβρική έκφραση της μεταβλητής <code>i</code>).",
                 "Σφάλμα στην τιμή μεταβολής της μεταβλητής <code>x</code>."];

var userEntriesIDs=["xStart",
                    "loopFrom",
                    "loopTo",
                    "loopStep",
                    "xConditional",
                    "iConditional",
                    "xExpression",
                    "iExpression",
                    "xStep"];

var logicalErrors="";
	
//Η επιλογή των τιμών επιτρέπει ταυτόχρονο έλεγχο με AND 
var numericEntry=1;
var comparatorEntry=2;
var textEntry=4;
var conditionalEntry=8;
var expressionEntry=16;

var entryTypes=[numericEntry,
                numericEntry,
                numericEntry,
                numericEntry,
                conditionalEntry,
                conditionalEntry,
                expressionEntry,
                expressionEntry,
                numericEntry];

var userValues=[0,0,0,0,0,0,0,0,0];

var hintLevel=-1;